"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/js/spa.js
var spa_exports = {};
__export(spa_exports, {
  PureSPA: () => PureSPA
});
module.exports = __toCommonJS(spa_exports);

// node_modules/@lit-labs/ssr-dom-shim/lib/element-internals.js
var ElementInternalsShim = class ElementInternals {
  get shadowRoot() {
    return this.__host.__shadowRoot;
  }
  constructor(_host) {
    this.ariaAtomic = "";
    this.ariaAutoComplete = "";
    this.ariaBraileLabel = "";
    this.ariaBraileRoleDescription = "";
    this.ariaBusy = "";
    this.ariaChecked = "";
    this.ariaColCount = "";
    this.ariaColIndex = "";
    this.ariaColSpan = "";
    this.ariaCurrent = "";
    this.ariaDescription = "";
    this.ariaDisabled = "";
    this.ariaExpanded = "";
    this.ariaHasPopup = "";
    this.ariaHidden = "";
    this.ariaInvalid = "";
    this.ariaKeyShortcuts = "";
    this.ariaLabel = "";
    this.ariaLevel = "";
    this.ariaLive = "";
    this.ariaModal = "";
    this.ariaMultiLine = "";
    this.ariaMultiSelectable = "";
    this.ariaOrientation = "";
    this.ariaPlaceholder = "";
    this.ariaPosInSet = "";
    this.ariaPressed = "";
    this.ariaReadOnly = "";
    this.ariaRequired = "";
    this.ariaRoleDescription = "";
    this.ariaRowCount = "";
    this.ariaRowIndex = "";
    this.ariaRowSpan = "";
    this.ariaSelected = "";
    this.ariaSetSize = "";
    this.ariaSort = "";
    this.ariaValueMax = "";
    this.ariaValueMin = "";
    this.ariaValueNow = "";
    this.ariaValueText = "";
    this.role = "";
    this.form = null;
    this.labels = [];
    this.states = /* @__PURE__ */ new Set();
    this.validationMessage = "";
    this.validity = {};
    this.willValidate = true;
    this.__host = _host;
  }
  checkValidity() {
    console.warn("`ElementInternals.checkValidity()` was called on the server.This method always returns true.");
    return true;
  }
  reportValidity() {
    return true;
  }
  setFormValue() {
  }
  setValidity() {
  }
};

// node_modules/@lit-labs/ssr-dom-shim/index.js
var attributes = /* @__PURE__ */ new WeakMap();
var attributesForElement = (element) => {
  let attrs = attributes.get(element);
  if (attrs === void 0) {
    attributes.set(element, attrs = /* @__PURE__ */ new Map());
  }
  return attrs;
};
var ElementShim = class Element {
  constructor() {
    this.__shadowRootMode = null;
    this.__shadowRoot = null;
    this.__internals = null;
  }
  get attributes() {
    return Array.from(attributesForElement(this)).map(([name, value]) => ({
      name,
      value
    }));
  }
  get shadowRoot() {
    if (this.__shadowRootMode === "closed") {
      return null;
    }
    return this.__shadowRoot;
  }
  setAttribute(name, value) {
    attributesForElement(this).set(name, String(value));
  }
  removeAttribute(name) {
    attributesForElement(this).delete(name);
  }
  toggleAttribute(name, force) {
    if (this.hasAttribute(name)) {
      if (force === void 0 || !force) {
        this.removeAttribute(name);
        return false;
      }
    } else {
      if (force === void 0 || force) {
        this.setAttribute(name, "");
        return true;
      } else {
        return false;
      }
    }
    return true;
  }
  hasAttribute(name) {
    return attributesForElement(this).has(name);
  }
  attachShadow(init) {
    const shadowRoot = { host: this };
    this.__shadowRootMode = init.mode;
    if (init && init.mode === "open") {
      this.__shadowRoot = shadowRoot;
    }
    return shadowRoot;
  }
  attachInternals() {
    if (this.__internals !== null) {
      throw new Error(`Failed to execute 'attachInternals' on 'HTMLElement': ElementInternals for the specified element was already attached.`);
    }
    const internals = new ElementInternalsShim(this);
    this.__internals = internals;
    return internals;
  }
  getAttribute(name) {
    const value = attributesForElement(this).get(name);
    return value ?? null;
  }
};
var HTMLElementShim = class HTMLElement extends ElementShim {
};
var HTMLElementShimWithRealType = HTMLElementShim;
var CustomElementRegistryShim = class CustomElementRegistry {
  constructor() {
    this.__definitions = /* @__PURE__ */ new Map();
  }
  define(name, ctor) {
    if (this.__definitions.has(name)) {
      if (process.env.NODE_ENV === "development") {
        console.warn(`'CustomElementRegistry' already has "${name}" defined. This may have been caused by live reload or hot module replacement in which case it can be safely ignored.
Make sure to test your application with a production build as repeat registrations will throw in production.`);
      } else {
        throw new Error(`Failed to execute 'define' on 'CustomElementRegistry': the name "${name}" has already been used with this registry`);
      }
    }
    this.__definitions.set(name, {
      ctor,
      // Note it's important we read `observedAttributes` in case it is a getter
      // with side-effects, as is the case in Lit, where it triggers class
      // finalization.
      //
      // TODO(aomarks) To be spec compliant, we should also capture the
      // registration-time lifecycle methods like `connectedCallback`. For them
      // to be actually accessible to e.g. the Lit SSR element renderer, though,
      // we'd need to introduce a new API for accessing them (since `get` only
      // returns the constructor).
      observedAttributes: ctor.observedAttributes ?? []
    });
  }
  get(name) {
    const definition = this.__definitions.get(name);
    return definition?.ctor;
  }
};
var CustomElementRegistryShimWithRealType = CustomElementRegistryShim;
var customElements2 = new CustomElementRegistryShimWithRealType();

// node_modules/@lit/reactive-element/node/css-tag.js
var t = globalThis;
var e = t.ShadowRoot && (void 0 === t.ShadyCSS || t.ShadyCSS.nativeShadow) && "adoptedStyleSheets" in Document.prototype && "replace" in CSSStyleSheet.prototype;
var s = Symbol();
var o = /* @__PURE__ */ new WeakMap();
var n = class {
  constructor(t5, e4, o5) {
    if (this._$cssResult$ = true, o5 !== s) throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");
    this.cssText = t5, this.t = e4;
  }
  get styleSheet() {
    let t5 = this.o;
    const s6 = this.t;
    if (e && void 0 === t5) {
      const e4 = void 0 !== s6 && 1 === s6.length;
      e4 && (t5 = o.get(s6)), void 0 === t5 && ((this.o = t5 = new CSSStyleSheet()).replaceSync(this.cssText), e4 && o.set(s6, t5));
    }
    return t5;
  }
  toString() {
    return this.cssText;
  }
};
var r = (t5) => new n("string" == typeof t5 ? t5 : t5 + "", void 0, s);
var i = (t5, ...e4) => {
  const o5 = 1 === t5.length ? t5[0] : e4.reduce((e5, s6, o6) => e5 + ((t6) => {
    if (true === t6._$cssResult$) return t6.cssText;
    if ("number" == typeof t6) return t6;
    throw Error("Value passed to 'css' function must be a 'css' function result: " + t6 + ". Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.");
  })(s6) + t5[o6 + 1], t5[0]);
  return new n(o5, t5, s);
};
var S = (s6, o5) => {
  if (e) s6.adoptedStyleSheets = o5.map((t5) => t5 instanceof CSSStyleSheet ? t5 : t5.styleSheet);
  else for (const e4 of o5) {
    const o6 = document.createElement("style"), n6 = t.litNonce;
    void 0 !== n6 && o6.setAttribute("nonce", n6), o6.textContent = e4.cssText, s6.appendChild(o6);
  }
};
var c = e || void 0 === t.CSSStyleSheet ? (t5) => t5 : (t5) => t5 instanceof CSSStyleSheet ? ((t6) => {
  let e4 = "";
  for (const s6 of t6.cssRules) e4 += s6.cssText;
  return r(e4);
})(t5) : t5;

// node_modules/@lit/reactive-element/node/reactive-element.js
var { is: r2, defineProperty: h, getOwnPropertyDescriptor: o2, getOwnPropertyNames: n2, getOwnPropertySymbols: a, getPrototypeOf: c2 } = Object;
var l = globalThis;
l.customElements ??= customElements2;
var p = l.trustedTypes;
var d = p ? p.emptyScript : "";
var u = l.reactiveElementPolyfillSupport;
var f = (t5, s6) => t5;
var b = { toAttribute(t5, s6) {
  switch (s6) {
    case Boolean:
      t5 = t5 ? d : null;
      break;
    case Object:
    case Array:
      t5 = null == t5 ? t5 : JSON.stringify(t5);
  }
  return t5;
}, fromAttribute(t5, s6) {
  let i6 = t5;
  switch (s6) {
    case Boolean:
      i6 = null !== t5;
      break;
    case Number:
      i6 = null === t5 ? null : Number(t5);
      break;
    case Object:
    case Array:
      try {
        i6 = JSON.parse(t5);
      } catch (t6) {
        i6 = null;
      }
  }
  return i6;
} };
var y = (t5, s6) => !r2(t5, s6);
var m = { attribute: true, type: String, converter: b, reflect: false, hasChanged: y };
Symbol.metadata ??= Symbol("metadata"), l.litPropertyMetadata ??= /* @__PURE__ */ new WeakMap();
var g = class extends (globalThis.HTMLElement ?? HTMLElementShimWithRealType) {
  static addInitializer(t5) {
    this._$Ei(), (this.l ??= []).push(t5);
  }
  static get observedAttributes() {
    return this.finalize(), this._$Eh && [...this._$Eh.keys()];
  }
  static createProperty(t5, s6 = m) {
    if (s6.state && (s6.attribute = false), this._$Ei(), this.elementProperties.set(t5, s6), !s6.noAccessor) {
      const i6 = Symbol(), e4 = this.getPropertyDescriptor(t5, i6, s6);
      void 0 !== e4 && h(this.prototype, t5, e4);
    }
  }
  static getPropertyDescriptor(t5, s6, i6) {
    const { get: e4, set: r6 } = o2(this.prototype, t5) ?? { get() {
      return this[s6];
    }, set(t6) {
      this[s6] = t6;
    } };
    return { get() {
      return e4?.call(this);
    }, set(s7) {
      const h5 = e4?.call(this);
      r6.call(this, s7), this.requestUpdate(t5, h5, i6);
    }, configurable: true, enumerable: true };
  }
  static getPropertyOptions(t5) {
    return this.elementProperties.get(t5) ?? m;
  }
  static _$Ei() {
    if (this.hasOwnProperty(f("elementProperties"))) return;
    const t5 = c2(this);
    t5.finalize(), void 0 !== t5.l && (this.l = [...t5.l]), this.elementProperties = new Map(t5.elementProperties);
  }
  static finalize() {
    if (this.hasOwnProperty(f("finalized"))) return;
    if (this.finalized = true, this._$Ei(), this.hasOwnProperty(f("properties"))) {
      const t6 = this.properties, s6 = [...n2(t6), ...a(t6)];
      for (const i6 of s6) this.createProperty(i6, t6[i6]);
    }
    const t5 = this[Symbol.metadata];
    if (null !== t5) {
      const s6 = litPropertyMetadata.get(t5);
      if (void 0 !== s6) for (const [t6, i6] of s6) this.elementProperties.set(t6, i6);
    }
    this._$Eh = /* @__PURE__ */ new Map();
    for (const [t6, s6] of this.elementProperties) {
      const i6 = this._$Eu(t6, s6);
      void 0 !== i6 && this._$Eh.set(i6, t6);
    }
    this.elementStyles = this.finalizeStyles(this.styles);
  }
  static finalizeStyles(t5) {
    const s6 = [];
    if (Array.isArray(t5)) {
      const e4 = new Set(t5.flat(1 / 0).reverse());
      for (const t6 of e4) s6.unshift(c(t6));
    } else void 0 !== t5 && s6.push(c(t5));
    return s6;
  }
  static _$Eu(t5, s6) {
    const i6 = s6.attribute;
    return false === i6 ? void 0 : "string" == typeof i6 ? i6 : "string" == typeof t5 ? t5.toLowerCase() : void 0;
  }
  constructor() {
    super(), this._$Ep = void 0, this.isUpdatePending = false, this.hasUpdated = false, this._$Em = null, this._$Ev();
  }
  _$Ev() {
    this._$ES = new Promise((t5) => this.enableUpdating = t5), this._$AL = /* @__PURE__ */ new Map(), this._$E_(), this.requestUpdate(), this.constructor.l?.forEach((t5) => t5(this));
  }
  addController(t5) {
    (this._$EO ??= /* @__PURE__ */ new Set()).add(t5), void 0 !== this.renderRoot && this.isConnected && t5.hostConnected?.();
  }
  removeController(t5) {
    this._$EO?.delete(t5);
  }
  _$E_() {
    const t5 = /* @__PURE__ */ new Map(), s6 = this.constructor.elementProperties;
    for (const i6 of s6.keys()) this.hasOwnProperty(i6) && (t5.set(i6, this[i6]), delete this[i6]);
    t5.size > 0 && (this._$Ep = t5);
  }
  createRenderRoot() {
    const t5 = this.shadowRoot ?? this.attachShadow(this.constructor.shadowRootOptions);
    return S(t5, this.constructor.elementStyles), t5;
  }
  connectedCallback() {
    this.renderRoot ??= this.createRenderRoot(), this.enableUpdating(true), this._$EO?.forEach((t5) => t5.hostConnected?.());
  }
  enableUpdating(t5) {
  }
  disconnectedCallback() {
    this._$EO?.forEach((t5) => t5.hostDisconnected?.());
  }
  attributeChangedCallback(t5, s6, i6) {
    this._$AK(t5, i6);
  }
  _$EC(t5, s6) {
    const i6 = this.constructor.elementProperties.get(t5), e4 = this.constructor._$Eu(t5, i6);
    if (void 0 !== e4 && true === i6.reflect) {
      const r6 = (void 0 !== i6.converter?.toAttribute ? i6.converter : b).toAttribute(s6, i6.type);
      this._$Em = t5, null == r6 ? this.removeAttribute(e4) : this.setAttribute(e4, r6), this._$Em = null;
    }
  }
  _$AK(t5, s6) {
    const i6 = this.constructor, e4 = i6._$Eh.get(t5);
    if (void 0 !== e4 && this._$Em !== e4) {
      const t6 = i6.getPropertyOptions(e4), r6 = "function" == typeof t6.converter ? { fromAttribute: t6.converter } : void 0 !== t6.converter?.fromAttribute ? t6.converter : b;
      this._$Em = e4, this[e4] = r6.fromAttribute(s6, t6.type), this._$Em = null;
    }
  }
  requestUpdate(t5, s6, i6) {
    if (void 0 !== t5) {
      if (i6 ??= this.constructor.getPropertyOptions(t5), !(i6.hasChanged ?? y)(this[t5], s6)) return;
      this.P(t5, s6, i6);
    }
    false === this.isUpdatePending && (this._$ES = this._$ET());
  }
  P(t5, s6, i6) {
    this._$AL.has(t5) || this._$AL.set(t5, s6), true === i6.reflect && this._$Em !== t5 && (this._$Ej ??= /* @__PURE__ */ new Set()).add(t5);
  }
  async _$ET() {
    this.isUpdatePending = true;
    try {
      await this._$ES;
    } catch (t6) {
      Promise.reject(t6);
    }
    const t5 = this.scheduleUpdate();
    return null != t5 && await t5, !this.isUpdatePending;
  }
  scheduleUpdate() {
    return this.performUpdate();
  }
  performUpdate() {
    if (!this.isUpdatePending) return;
    if (!this.hasUpdated) {
      if (this.renderRoot ??= this.createRenderRoot(), this._$Ep) {
        for (const [t7, s7] of this._$Ep) this[t7] = s7;
        this._$Ep = void 0;
      }
      const t6 = this.constructor.elementProperties;
      if (t6.size > 0) for (const [s7, i6] of t6) true !== i6.wrapped || this._$AL.has(s7) || void 0 === this[s7] || this.P(s7, this[s7], i6);
    }
    let t5 = false;
    const s6 = this._$AL;
    try {
      t5 = this.shouldUpdate(s6), t5 ? (this.willUpdate(s6), this._$EO?.forEach((t6) => t6.hostUpdate?.()), this.update(s6)) : this._$EU();
    } catch (s7) {
      throw t5 = false, this._$EU(), s7;
    }
    t5 && this._$AE(s6);
  }
  willUpdate(t5) {
  }
  _$AE(t5) {
    this._$EO?.forEach((t6) => t6.hostUpdated?.()), this.hasUpdated || (this.hasUpdated = true, this.firstUpdated(t5)), this.updated(t5);
  }
  _$EU() {
    this._$AL = /* @__PURE__ */ new Map(), this.isUpdatePending = false;
  }
  get updateComplete() {
    return this.getUpdateComplete();
  }
  getUpdateComplete() {
    return this._$ES;
  }
  shouldUpdate(t5) {
    return true;
  }
  update(t5) {
    this._$Ej &&= this._$Ej.forEach((t6) => this._$EC(t6, this[t6])), this._$EU();
  }
  updated(t5) {
  }
  firstUpdated(t5) {
  }
};
g.elementStyles = [], g.shadowRootOptions = { mode: "open" }, g[f("elementProperties")] = /* @__PURE__ */ new Map(), g[f("finalized")] = /* @__PURE__ */ new Map(), u?.({ ReactiveElement: g }), (l.reactiveElementVersions ??= []).push("2.0.4");

// node_modules/lit-html/node/lit-html.js
var t2 = globalThis;
var i2 = t2.trustedTypes;
var s2 = i2 ? i2.createPolicy("lit-html", { createHTML: (t5) => t5 }) : void 0;
var e2 = "$lit$";
var h2 = `lit$${Math.random().toFixed(9).slice(2)}$`;
var o3 = "?" + h2;
var n3 = `<${o3}>`;
var r3 = void 0 === t2.document ? { createTreeWalker: () => ({}) } : document;
var l2 = () => r3.createComment("");
var c3 = (t5) => null === t5 || "object" != typeof t5 && "function" != typeof t5;
var a2 = Array.isArray;
var u2 = (t5) => a2(t5) || "function" == typeof t5?.[Symbol.iterator];
var d2 = "[ 	\n\f\r]";
var f2 = /<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g;
var v = /-->/g;
var _ = />/g;
var m2 = RegExp(`>|${d2}(?:([^\\s"'>=/]+)(${d2}*=${d2}*(?:[^ 	
\f\r"'\`<>=]|("|')|))|$)`, "g");
var p2 = /'/g;
var g2 = /"/g;
var $ = /^(?:script|style|textarea|title)$/i;
var y2 = (t5) => (i6, ...s6) => ({ _$litType$: t5, strings: i6, values: s6 });
var x = y2(1);
var T = y2(2);
var b2 = Symbol.for("lit-noChange");
var w = Symbol.for("lit-nothing");
var A = /* @__PURE__ */ new WeakMap();
var E = r3.createTreeWalker(r3, 129);
function C(t5, i6) {
  if (!Array.isArray(t5) || !t5.hasOwnProperty("raw")) throw Error("invalid template strings array");
  return void 0 !== s2 ? s2.createHTML(i6) : i6;
}
var P = (t5, i6) => {
  const s6 = t5.length - 1, o5 = [];
  let r6, l3 = 2 === i6 ? "<svg>" : "", c6 = f2;
  for (let i7 = 0; i7 < s6; i7++) {
    const s7 = t5[i7];
    let a3, u3, d3 = -1, y3 = 0;
    for (; y3 < s7.length && (c6.lastIndex = y3, u3 = c6.exec(s7), null !== u3); ) y3 = c6.lastIndex, c6 === f2 ? "!--" === u3[1] ? c6 = v : void 0 !== u3[1] ? c6 = _ : void 0 !== u3[2] ? ($.test(u3[2]) && (r6 = RegExp("</" + u3[2], "g")), c6 = m2) : void 0 !== u3[3] && (c6 = m2) : c6 === m2 ? ">" === u3[0] ? (c6 = r6 ?? f2, d3 = -1) : void 0 === u3[1] ? d3 = -2 : (d3 = c6.lastIndex - u3[2].length, a3 = u3[1], c6 = void 0 === u3[3] ? m2 : '"' === u3[3] ? g2 : p2) : c6 === g2 || c6 === p2 ? c6 = m2 : c6 === v || c6 === _ ? c6 = f2 : (c6 = m2, r6 = void 0);
    const x2 = c6 === m2 && t5[i7 + 1].startsWith("/>") ? " " : "";
    l3 += c6 === f2 ? s7 + n3 : d3 >= 0 ? (o5.push(a3), s7.slice(0, d3) + e2 + s7.slice(d3) + h2 + x2) : s7 + h2 + (-2 === d3 ? i7 : x2);
  }
  return [C(t5, l3 + (t5[s6] || "<?>") + (2 === i6 ? "</svg>" : "")), o5];
};
var V = class _V {
  constructor({ strings: t5, _$litType$: s6 }, n6) {
    let r6;
    this.parts = [];
    let c6 = 0, a3 = 0;
    const u3 = t5.length - 1, d3 = this.parts, [f5, v2] = P(t5, s6);
    if (this.el = _V.createElement(f5, n6), E.currentNode = this.el.content, 2 === s6) {
      const t6 = this.el.content.firstChild;
      t6.replaceWith(...t6.childNodes);
    }
    for (; null !== (r6 = E.nextNode()) && d3.length < u3; ) {
      if (1 === r6.nodeType) {
        if (r6.hasAttributes()) for (const t6 of r6.getAttributeNames()) if (t6.endsWith(e2)) {
          const i6 = v2[a3++], s7 = r6.getAttribute(t6).split(h2), e4 = /([.?@])?(.*)/.exec(i6);
          d3.push({ type: 1, index: c6, name: e4[2], strings: s7, ctor: "." === e4[1] ? R : "?" === e4[1] ? H : "@" === e4[1] ? I : k }), r6.removeAttribute(t6);
        } else t6.startsWith(h2) && (d3.push({ type: 6, index: c6 }), r6.removeAttribute(t6));
        if ($.test(r6.tagName)) {
          const t6 = r6.textContent.split(h2), s7 = t6.length - 1;
          if (s7 > 0) {
            r6.textContent = i2 ? i2.emptyScript : "";
            for (let i6 = 0; i6 < s7; i6++) r6.append(t6[i6], l2()), E.nextNode(), d3.push({ type: 2, index: ++c6 });
            r6.append(t6[s7], l2());
          }
        }
      } else if (8 === r6.nodeType) if (r6.data === o3) d3.push({ type: 2, index: c6 });
      else {
        let t6 = -1;
        for (; -1 !== (t6 = r6.data.indexOf(h2, t6 + 1)); ) d3.push({ type: 7, index: c6 }), t6 += h2.length - 1;
      }
      c6++;
    }
  }
  static createElement(t5, i6) {
    const s6 = r3.createElement("template");
    return s6.innerHTML = t5, s6;
  }
};
function N(t5, i6, s6 = t5, e4) {
  if (i6 === b2) return i6;
  let h5 = void 0 !== e4 ? s6._$Co?.[e4] : s6._$Cl;
  const o5 = c3(i6) ? void 0 : i6._$litDirective$;
  return h5?.constructor !== o5 && (h5?._$AO?.(false), void 0 === o5 ? h5 = void 0 : (h5 = new o5(t5), h5._$AT(t5, s6, e4)), void 0 !== e4 ? (s6._$Co ??= [])[e4] = h5 : s6._$Cl = h5), void 0 !== h5 && (i6 = N(t5, h5._$AS(t5, i6.values), h5, e4)), i6;
}
var S2 = class {
  constructor(t5, i6) {
    this._$AV = [], this._$AN = void 0, this._$AD = t5, this._$AM = i6;
  }
  get parentNode() {
    return this._$AM.parentNode;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  u(t5) {
    const { el: { content: i6 }, parts: s6 } = this._$AD, e4 = (t5?.creationScope ?? r3).importNode(i6, true);
    E.currentNode = e4;
    let h5 = E.nextNode(), o5 = 0, n6 = 0, l3 = s6[0];
    for (; void 0 !== l3; ) {
      if (o5 === l3.index) {
        let i7;
        2 === l3.type ? i7 = new M(h5, h5.nextSibling, this, t5) : 1 === l3.type ? i7 = new l3.ctor(h5, l3.name, l3.strings, this, t5) : 6 === l3.type && (i7 = new L(h5, this, t5)), this._$AV.push(i7), l3 = s6[++n6];
      }
      o5 !== l3?.index && (h5 = E.nextNode(), o5++);
    }
    return E.currentNode = r3, e4;
  }
  p(t5) {
    let i6 = 0;
    for (const s6 of this._$AV) void 0 !== s6 && (void 0 !== s6.strings ? (s6._$AI(t5, s6, i6), i6 += s6.strings.length - 2) : s6._$AI(t5[i6])), i6++;
  }
};
var M = class _M {
  get _$AU() {
    return this._$AM?._$AU ?? this._$Cv;
  }
  constructor(t5, i6, s6, e4) {
    this.type = 2, this._$AH = w, this._$AN = void 0, this._$AA = t5, this._$AB = i6, this._$AM = s6, this.options = e4, this._$Cv = e4?.isConnected ?? true;
  }
  get parentNode() {
    let t5 = this._$AA.parentNode;
    const i6 = this._$AM;
    return void 0 !== i6 && 11 === t5?.nodeType && (t5 = i6.parentNode), t5;
  }
  get startNode() {
    return this._$AA;
  }
  get endNode() {
    return this._$AB;
  }
  _$AI(t5, i6 = this) {
    t5 = N(this, t5, i6), c3(t5) ? t5 === w || null == t5 || "" === t5 ? (this._$AH !== w && this._$AR(), this._$AH = w) : t5 !== this._$AH && t5 !== b2 && this._(t5) : void 0 !== t5._$litType$ ? this.$(t5) : void 0 !== t5.nodeType ? this.T(t5) : u2(t5) ? this.k(t5) : this._(t5);
  }
  S(t5) {
    return this._$AA.parentNode.insertBefore(t5, this._$AB);
  }
  T(t5) {
    this._$AH !== t5 && (this._$AR(), this._$AH = this.S(t5));
  }
  _(t5) {
    this._$AH !== w && c3(this._$AH) ? this._$AA.nextSibling.data = t5 : this.T(r3.createTextNode(t5)), this._$AH = t5;
  }
  $(t5) {
    const { values: i6, _$litType$: s6 } = t5, e4 = "number" == typeof s6 ? this._$AC(t5) : (void 0 === s6.el && (s6.el = V.createElement(C(s6.h, s6.h[0]), this.options)), s6);
    if (this._$AH?._$AD === e4) this._$AH.p(i6);
    else {
      const t6 = new S2(e4, this), s7 = t6.u(this.options);
      t6.p(i6), this.T(s7), this._$AH = t6;
    }
  }
  _$AC(t5) {
    let i6 = A.get(t5.strings);
    return void 0 === i6 && A.set(t5.strings, i6 = new V(t5)), i6;
  }
  k(t5) {
    a2(this._$AH) || (this._$AH = [], this._$AR());
    const i6 = this._$AH;
    let s6, e4 = 0;
    for (const h5 of t5) e4 === i6.length ? i6.push(s6 = new _M(this.S(l2()), this.S(l2()), this, this.options)) : s6 = i6[e4], s6._$AI(h5), e4++;
    e4 < i6.length && (this._$AR(s6 && s6._$AB.nextSibling, e4), i6.length = e4);
  }
  _$AR(t5 = this._$AA.nextSibling, i6) {
    for (this._$AP?.(false, true, i6); t5 && t5 !== this._$AB; ) {
      const i7 = t5.nextSibling;
      t5.remove(), t5 = i7;
    }
  }
  setConnected(t5) {
    void 0 === this._$AM && (this._$Cv = t5, this._$AP?.(t5));
  }
};
var k = class {
  get tagName() {
    return this.element.tagName;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  constructor(t5, i6, s6, e4, h5) {
    this.type = 1, this._$AH = w, this._$AN = void 0, this.element = t5, this.name = i6, this._$AM = e4, this.options = h5, s6.length > 2 || "" !== s6[0] || "" !== s6[1] ? (this._$AH = Array(s6.length - 1).fill(new String()), this.strings = s6) : this._$AH = w;
  }
  _$AI(t5, i6 = this, s6, e4) {
    const h5 = this.strings;
    let o5 = false;
    if (void 0 === h5) t5 = N(this, t5, i6, 0), o5 = !c3(t5) || t5 !== this._$AH && t5 !== b2, o5 && (this._$AH = t5);
    else {
      const e5 = t5;
      let n6, r6;
      for (t5 = h5[0], n6 = 0; n6 < h5.length - 1; n6++) r6 = N(this, e5[s6 + n6], i6, n6), r6 === b2 && (r6 = this._$AH[n6]), o5 ||= !c3(r6) || r6 !== this._$AH[n6], r6 === w ? t5 = w : t5 !== w && (t5 += (r6 ?? "") + h5[n6 + 1]), this._$AH[n6] = r6;
    }
    o5 && !e4 && this.j(t5);
  }
  j(t5) {
    t5 === w ? this.element.removeAttribute(this.name) : this.element.setAttribute(this.name, t5 ?? "");
  }
};
var R = class extends k {
  constructor() {
    super(...arguments), this.type = 3;
  }
  j(t5) {
    this.element[this.name] = t5 === w ? void 0 : t5;
  }
};
var H = class extends k {
  constructor() {
    super(...arguments), this.type = 4;
  }
  j(t5) {
    this.element.toggleAttribute(this.name, !!t5 && t5 !== w);
  }
};
var I = class extends k {
  constructor(t5, i6, s6, e4, h5) {
    super(t5, i6, s6, e4, h5), this.type = 5;
  }
  _$AI(t5, i6 = this) {
    if ((t5 = N(this, t5, i6, 0) ?? w) === b2) return;
    const s6 = this._$AH, e4 = t5 === w && s6 !== w || t5.capture !== s6.capture || t5.once !== s6.once || t5.passive !== s6.passive, h5 = t5 !== w && (s6 === w || e4);
    e4 && this.element.removeEventListener(this.name, this, s6), h5 && this.element.addEventListener(this.name, this, t5), this._$AH = t5;
  }
  handleEvent(t5) {
    "function" == typeof this._$AH ? this._$AH.call(this.options?.host ?? this.element, t5) : this._$AH.handleEvent(t5);
  }
};
var L = class {
  constructor(t5, i6, s6) {
    this.element = t5, this.type = 6, this._$AN = void 0, this._$AM = i6, this.options = s6;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AI(t5) {
    N(this, t5);
  }
};
var z = { P: e2, A: h2, C: o3, M: 1, L: P, R: S2, D: u2, V: N, I: M, H: k, N: H, U: I, B: R, F: L };
var W = t2.litHtmlPolyfillSupport;
W?.(V, M), (t2.litHtmlVersions ??= []).push("3.1.4");
var Z = (t5, i6, s6) => {
  const e4 = s6?.renderBefore ?? i6;
  let h5 = e4._$litPart$;
  if (void 0 === h5) {
    const t6 = s6?.renderBefore ?? null;
    e4._$litPart$ = h5 = new M(i6.insertBefore(l2(), t6), t6, void 0, s6 ?? {});
  }
  return h5._$AI(t5), h5;
};

// node_modules/lit-element/lit-element.js
var s3 = class extends g {
  constructor() {
    super(...arguments), this.renderOptions = { host: this }, this._$Do = void 0;
  }
  createRenderRoot() {
    const t5 = super.createRenderRoot();
    return this.renderOptions.renderBefore ??= t5.firstChild, t5;
  }
  update(t5) {
    const i6 = this.render();
    this.hasUpdated || (this.renderOptions.isConnected = this.isConnected), super.update(t5), this._$Do = Z(i6, this.renderRoot, this.renderOptions);
  }
  connectedCallback() {
    super.connectedCallback(), this._$Do?.setConnected(true);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this._$Do?.setConnected(false);
  }
  render() {
    return b2;
  }
};
s3._$litElement$ = true, s3["finalized", "finalized"] = true, globalThis.litElementHydrateSupport?.({ LitElement: s3 });
var r4 = globalThis.litElementPolyfillSupport;
r4?.({ LitElement: s3 });
(globalThis.litElementVersions ??= []).push("4.0.6");

// node_modules/lit-html/node/directive-helpers.js
var { I: t3 } = z;
var i3 = (o5) => null === o5 || "object" != typeof o5 && "function" != typeof o5;
var f3 = (o5) => void 0 === o5.strings;

// node_modules/lit-html/node/directive.js
var t4 = { ATTRIBUTE: 1, CHILD: 2, PROPERTY: 3, BOOLEAN_ATTRIBUTE: 4, EVENT: 5, ELEMENT: 6 };
var e3 = (t5) => (...e4) => ({ _$litDirective$: t5, values: e4 });
var i4 = class {
  constructor(t5) {
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AT(t5, e4, i6) {
    this._$Ct = t5, this._$AM = e4, this._$Ci = i6;
  }
  _$AS(t5, e4) {
    return this.update(t5, e4);
  }
  update(t5, e4) {
    return this.render(...e4);
  }
};

// node_modules/lit-html/node/async-directive.js
var s4 = (i6, t5) => {
  const e4 = i6._$AN;
  if (void 0 === e4) return false;
  for (const i7 of e4) i7._$AO?.(t5, false), s4(i7, t5);
  return true;
};
var o4 = (i6) => {
  let t5, e4;
  do {
    if (void 0 === (t5 = i6._$AM)) break;
    e4 = t5._$AN, e4.delete(i6), i6 = t5;
  } while (0 === e4?.size);
};
var r5 = (i6) => {
  for (let t5; t5 = i6._$AM; i6 = t5) {
    let e4 = t5._$AN;
    if (void 0 === e4) t5._$AN = e4 = /* @__PURE__ */ new Set();
    else if (e4.has(i6)) break;
    e4.add(i6), c4(t5);
  }
};
function h3(i6) {
  void 0 !== this._$AN ? (o4(this), this._$AM = i6, r5(this)) : this._$AM = i6;
}
function n4(i6, t5 = false, e4 = 0) {
  const r6 = this._$AH, h5 = this._$AN;
  if (void 0 !== h5 && 0 !== h5.size) if (t5) if (Array.isArray(r6)) for (let i7 = e4; i7 < r6.length; i7++) s4(r6[i7], false), o4(r6[i7]);
  else null != r6 && (s4(r6, false), o4(r6));
  else s4(this, i6);
}
var c4 = (i6) => {
  i6.type == t4.CHILD && (i6._$AP ??= n4, i6._$AQ ??= h3);
};
var f4 = class extends i4 {
  constructor() {
    super(...arguments), this._$AN = void 0;
  }
  _$AT(i6, t5, e4) {
    super._$AT(i6, t5, e4), r5(this), this.isConnected = i6._$AU;
  }
  _$AO(i6, t5 = true) {
    i6 !== this.isConnected && (this.isConnected = i6, i6 ? this.reconnected?.() : this.disconnected?.()), t5 && (s4(this, i6), o4(this));
  }
  setValue(t5) {
    if (f3(this._$Ct)) this._$Ct._$AI(t5, this);
    else {
      const i6 = [...this._$Ct._$AH];
      i6[this._$Ci] = t5, this._$Ct._$AI(i6, this, 0);
    }
  }
  disconnected() {
  }
  reconnected() {
  }
};

// node_modules/lit-html/node/directives/private-async-helpers.js
var s5 = class {
  constructor(t5) {
    this.Y = t5;
  }
  disconnect() {
    this.Y = void 0;
  }
  reconnect(t5) {
    this.Y = t5;
  }
  deref() {
    return this.Y;
  }
};
var i5 = class {
  constructor() {
    this.Z = void 0, this.q = void 0;
  }
  get() {
    return this.Z;
  }
  pause() {
    this.Z ??= new Promise((t5) => this.q = t5);
  }
  resume() {
    this.q?.(), this.Z = this.q = void 0;
  }
};

// node_modules/lit-html/node/directives/until.js
var n5 = (t5) => !i3(t5) && "function" == typeof t5.then;
var h4 = 1073741823;
var c5 = class extends f4 {
  constructor() {
    super(...arguments), this._$Cwt = h4, this._$Cbt = [], this._$CK = new s5(this), this._$CX = new i5();
  }
  render(...s6) {
    return s6.find((t5) => !n5(t5)) ?? b2;
  }
  update(s6, i6) {
    const e4 = this._$Cbt;
    let r6 = e4.length;
    this._$Cbt = i6;
    const o5 = this._$CK, c6 = this._$CX;
    this.isConnected || this.disconnected();
    for (let t5 = 0; t5 < i6.length && !(t5 > this._$Cwt); t5++) {
      const s7 = i6[t5];
      if (!n5(s7)) return this._$Cwt = t5, s7;
      t5 < r6 && s7 === e4[t5] || (this._$Cwt = h4, r6 = 0, Promise.resolve(s7).then(async (t6) => {
        for (; c6.get(); ) await c6.get();
        const i7 = o5.deref();
        if (void 0 !== i7) {
          const e5 = i7._$Cbt.indexOf(s7);
          e5 > -1 && e5 < i7._$Cwt && (i7._$Cwt = e5, i7.setValue(t6));
        }
      }));
    }
    return b2;
  }
  disconnected() {
    this._$CK.disconnect(), this._$CX.pause();
  }
  reconnected() {
    this._$CK.reconnect(this), this._$CX.resume();
  }
};
var m3 = e3(c5);

// src/js/polyfills/polyfillsLoader.js
async function LoadPolyfillsIfNeeded() {
  if (!(globalThis && "URLPattern" in globalThis)) {
    console.log("URLPattern polyfill is needed...");
    const path = "/assets/js/polyfills/urlpattern-polyfill.js";
    await import(path);
  }
  if (!(globalThis && "navigation" in globalThis)) {
    console.log("Navigation polyfill is needed...");
    const path = "/assets/js/polyfills/navigation-polyfill.js";
    await import(path);
  }
  if (!(document && "startViewTransition" in document)) {
    console.log("View-transition polyfill is needed...");
    const path = "/assets/js/polyfills/view-transition-polyfill.js";
    await import(path);
  }
}
var polyfillsLoaded = LoadPolyfillsIfNeeded();

// src/js/spa.js
var toWords = (text) => {
  text = text.replace(/([A-Z])/g, " $1");
  return text.charAt(0).toUpperCase() + text.slice(1);
};
var kebabToPascal = (str) => {
  return str.split("-").map((word) => word.charAt(0).toUpperCase() + word.slice(1)).join("");
};
var toBoolean = (value) => {
  switch (typeof value) {
    case "boolean":
      return value;
    case "string":
      return ["true", "false"].includes(value.toLowerCase());
    case "number":
      return value !== 0;
    default:
      return false;
  }
};
var isWellFormedConfig = (config) => {
  return typeof config?.routes === "object";
};
var BOOLEAN_ATTRIBUTES = "hidden,required,disabled,readonly".split(",");
var debug = ["localhost", "127.0.0.1"].includes(location.hostname);
var PureSPAConfig = class {
  #rawConfig;
  #routes = {};
  #pages;
  #widgets;
  constructor(rawConfig) {
    this.#rawConfig = rawConfig;
    this.readConfig();
  }
  readConfig() {
    if (!isWellFormedConfig(this.#rawConfig))
      throw Error("Config mising or malformed");
    const createRender = (path, tagName, widget, properties) => {
      return (routeData) => {
        properties = PureSPA.mapRouterVariables(tagName, properties, routeData);
        return PureSPA.createCustomTagLitHtml(tagName, {
          routeKey: path,
          widget,
          routeData,
          ...properties
        });
      };
    };
    const traverseRoutes = (configPart, basePath = "") => {
      for (const [route, options] of Object.entries(configPart)) {
        const path = basePath + route;
        const parentConfig = this.#routes[basePath];
        let widgetSettings = {};
        if (options.run && options.run.widgetSettings) {
          widgetSettings = options.run.widgetSettings;
        }
        let subRouteName = route.substring(1);
        let cleanSubRouteName = (subRouteName || "home").split("?")[0].toLowerCase();
        const hasPattern = subRouteName.indexOf(":") !== -1 || subRouteName.indexOf("?") !== -1 || subRouteName.indexOf("#") !== -1;
        if (hasPattern)
          cleanSubRouteName = cleanSubRouteName.replace(
            new RegExp("/|:|#", "g"),
            ""
          );
        let tagName = options.tagName;
        if (!tagName) {
          if (hasPattern) {
            if (!parentConfig) {
              if (!options.run)
                throw Error(
                  "Invalid routing config for subroute (" + basePath + ")"
                );
            } else {
              tagName = parentConfig.tagName;
              if (options.run && parentConfig.run !== options.run) {
                tagName = `${parentConfig.tagName}-${cleanSubRouteName}`.trim();
              }
            }
          } else {
            if (parentConfig) {
              tagName = `${parentConfig.tagName}-${subRouteName}`.trim();
            } else {
              tagName = `page-${cleanSubRouteName.toLowerCase().replace(new RegExp("/", "g"), "-")}`;
            }
          }
        }
        if (tagName && options.run) {
          customElements.define(tagName, options.run);
        }
        this.#routes[path] = {
          id: tagName.replace(/-/g, "_"),
          route: path,
          path: path.split("?")[0],
          parentRoute: basePath || void 0,
          isDetail: hasPattern,
          hidden: options.hidden ?? hasPattern,
          customPage: options.renderPage,
          renderPage: options.renderPage ?? createRender(path, tagName),
          widgetSettings,
          customWidget: options.renderWidget,
          renderWidget: options.renderWidget ?? createRender(path, tagName, true),
          name: options.name ?? toWords(subRouteName),
          tagName,
          definedBy: options.className ?? kebabToPascal(tagName),
          ...options
        };
        if (options.routes) {
          traverseRoutes(options.routes, path);
        }
      }
    };
    traverseRoutes(this.#rawConfig.routes);
    this.#pages = Object.values(this.#routes).map((options) => {
      return {
        ...options
      };
    }).filter((p3) => !p3.hidden);
  }
  /**
   * Returns all widgets (either custom ones defined in the config,
   * or page classes extending WidgetEnabledPage)
   */
  get widgets() {
    const createElement = (t5) => {
      try {
        return document.createElement(t5);
      } catch {
        return {};
      }
    };
    if (!this.#widgets)
      this.#widgets = Object.values(this.#routes).filter((options) => !options.isDetail).map((options) => {
        return {
          ...options,
          widget: options.customWidget || createElement(options.tagName) instanceof PureSPA.WidgetEnabledPage
        };
      }).filter((i6) => i6.widget);
    return this.#widgets;
  }
  get routes() {
    return this.#routes;
  }
  get pages() {
    return this.#pages;
  }
};
var RoutePage = class extends s3 {
  static get properties() {
    return {
      routeKey: { type: String },
      routeData: { type: Object }
    };
  }
  /**
   * Returns the current route's properties as defined in the configuration
   */
  get routeProperties() {
    return app.config.routes[this.routeKey];
  }
  // use light DOM
  createRenderRoot() {
    return this;
  }
};
var WidgetEnabledRoutePage = class extends RoutePage {
  static get properties() {
    return {
      ...RoutePage.properties,
      widget: {
        type: Boolean,
        attribute: true
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    const isFn = typeof this.constructor.getWidgetSettings === "function";
    const settings = isFn ? this.constructor.getWidgetSettings() : {};
    if (settings?.full) {
      this.setAttribute("full", "");
    }
    this.setAttribute("priority", settings.priority ?? 0);
  }
  render() {
    if (this.widget) return this.renderWidget();
    return this.renderPage();
  }
  /**
   * Renders a widget to display elsewhere
   */
  renderWidget() {
    throw new Error("renderWidget() must be implemented.");
  }
  /**
   * Gets the widget's settings
   */
  getWidgetSettings() {
    return {
      priority: 0,
      full: false
    };
  }
  /**
   * Renders the page as a route component
   */
  renderPage() {
    throw new Error("renderPage() must be implemented.");
  }
};
var PureSPAEnhancementRegistry = class {
  #list = /* @__PURE__ */ new Map();
  add(selector, enhancementFn) {
    this.#list.set(selector, enhancementFn);
  }
  run(element) {
    for (const [selector, fn] of this.#list) {
      const nodes = element.querySelectorAll(selector);
      for (const node of nodes) {
        if (!node.hasAttribute("data-enhanced")) {
          const result = fn(node);
          node.setAttribute("data-enhanced", result?.toString() ?? "");
        }
      }
    }
  }
};
var PureSPA = class _PureSPA extends s3 {
  #config;
  #currentRoute;
  #routeMap = /* @__PURE__ */ new Map();
  #enhancers = new PureSPAEnhancementRegistry();
  constructor() {
    super();
    window.app = this;
  }
  connectedCallback() {
    super.connectedCallback();
    try {
      this.#config = new PureSPAConfig(this.constructor.config);
      this.#setGlobalAttributes();
      this.routerReady = this.initializeRouting();
    } catch (ex) {
      console.error("Configuration error: ", ex.toString());
    }
  }
  get enhancers() {
    return this.#enhancers;
  }
  /**
   * @returns {PureSPAConfig} configuration
   */
  get config() {
    return this.#config;
  }
  async initializeRouting() {
    const me = this;
    await polyfillsLoaded;
    const routes = {};
    for (const [path, options] of Object.entries(this.config.routes)) {
      routes[path] = options;
    }
    for (const r6 in routes) {
      this.#routeMap.set(new URLPattern(r6, window.location.origin), routes[r6]);
    }
    this.#routeMap.set(
      new URLPattern({
        pathname: "*",
        search: "*",
        baseURL: location.origin
      }),
      {
        route: "unknown",
        renderPage: this.notFoundPage
      }
    );
    window.navigation.addEventListener("navigate", (event) => {
      if (event.hashChange) return;
      const route = this.#getRoute(event.destination.url);
      if (!route) return;
      event.intercept({
        async handler() {
          document.startViewTransition(() => {
            me.setRouteContent(route.data);
            window.scrollTo({
              top: 0,
              left: 0,
              behavior: "instant"
            });
          });
        }
      });
    });
    console.log(this.config);
    await this.beforeRouting();
  }
  /**
   * get active route
   */
  get activeRoute() {
    return this.#currentRoute;
  }
  /**
   * Dispatch app-level event
   * @param {String} eventName
   * @param {Object} detail Optional details to pass along with event
   */
  fire(eventName, detail = {}) {
    this.dispatchEvent(
      new CustomEvent(eventName, {
        detail: detail || {}
      })
    );
  }
  /**
   * Listen for app-level event
   * @param {String} eventName
   * @param {Function} func
   */
  on(eventName, func) {
    this.addEventListener(eventName, func);
    return this;
  }
  /**
   * Stop listening to app-level event
   * @param {String} eventName
   * @param {Function} func
   */
  off(eventName, func) {
    this.removeEventListener(eventName, func);
    return this;
  }
  /**
   * Subclass this
   */
  async beforeRouting() {
  }
  #getRoute(urlString) {
    try {
      const url = new URL(urlString, location);
      const route = this.#findRoute(url);
      this.#setActiveRoute(route);
      try {
        return {
          route: route.pattern,
          data: typeof route.renderPage === "function" ? route.renderPage(route.patternResult) : route.renderPage,
          options: route
        };
      } finally {
        this.fireRouteComplete();
      }
    } catch (ex) {
      console.error("getRoute error: ", ex);
    }
  }
  #setActiveRoute(route) {
    if (this.#currentRoute) {
      this.fire("leaveroute", {
        route: this.#currentRoute.route
      });
    }
    this.#currentRoute = route;
    this.fire("activateroute", {
      route: this.#currentRoute
    });
    console.warn("Active Route: ", route.path ?? "INVALID");
  }
  #findRoute(url) {
    for (const [pattern, options] of this.#routeMap) {
      const patternResult = pattern.exec(url);
      if (patternResult)
        return {
          ...options,
          pattern,
          patternResult
        };
    }
    return;
  }
  fireRouteComplete() {
    this.fire("routecomplete", {
      route: this.#currentRoute
    });
  }
  async matchRouteWhenReady() {
    await this.routerReady;
    const url = window.location.href.split("?")[0];
    const route = this.#findRoute(url);
    this.#setActiveRoute(route);
    try {
      return typeof route.renderPage === "function" ? route.renderPage(route.patternResult) : route.renderPage;
    } finally {
      this.fireRouteComplete();
    }
  }
  matchRoute() {
    return m3(this.matchRouteWhenReady(), this.loadingPage);
  }
  /**
   * Subclass this to set the 404 page
   */
  get notFoundPage() {
    return x`<section class="block callout error">
      <h2>Not found</h2>
      <div class="center">
        <svg-icon icon="error" size="200px" color="#931620"></svg-icon>
      </div>
      <div>
        <h3>This page could not be found</h3>
      </div>
    </section>`;
  }
  updated() {
    super.updated();
    this.waitForFullRendering();
  }
  async waitForFullRendering() {
    await this.getUpdateComplete();
    setTimeout(() => {
      this.enhancers.run(this);
    }, 1);
  }
  /**
   * Sublass this to set the loading page html.
   */
  get loadingPage() {
    return x` <div class="fill skeleton">
      <app-shimmer class="title"></app-shimmer>
      <app-shimmer class="image"></app-shimmer>
      <app-shimmer></app-shimmer>
    </div>`;
  }
  goBack(fallback) {
    if (navigation.canGoBack) {
      history.back();
      return;
    }
    history.replaceState({}, "", fallback);
  }
  /**
   * Called from router
   * @param {Object} content - route data to render
   */
  setRouteContent(content) {
    this.content = content;
    this.requestUpdate();
    requestAnimationFrame(this.routeComplete.bind(this));
  }
  /**
   * Called when a route change is completed.
   */
  routeComplete() {
  }
  /**
   * Called on first page request.
   * On route changes (via router), setRouteContent()
   * is called from router, which forces re-render.
   */
  getRouteContent() {
    const route = this.matchRoute();
    this.content = new Promise((resolve) => {
      this.readyToRoute().then(() => {
        resolve(route);
        requestAnimationFrame(this.routeComplete.bind(this));
      });
    });
  }
  render() {
    if (!this.content) this.getRouteContent();
    return x`${m3(this.content, this.loadingPage)}`;
  }
  // PureApp is a Light DOM Web Component
  createRenderRoot() {
    return this;
  }
  // Lit properties
  static get properties() {
    return {
      config: { type: Object }
    };
  }
  /**
   * Subclass this for any initialization stuff that needs to run before the first route is rendered.
   * @returns {Boolean}
   */
  async readyToRoute() {
    return true;
  }
  // set <html> element attributes
  #setGlobalAttributes() {
    const htm = document.documentElement;
    if (debug) htm.setAttribute("debug", "");
  }
  /**
   * @returns {WidgetEnabledPage} Class that can be extended from in Routes that also have a Widget.
   */
  static get WidgetEnabledPage() {
    return WidgetEnabledRoutePage;
  }
  /**
   * @returns {RoutePage} Class that can be extended from in Routes.
   */
  static get Page() {
    return RoutePage;
  }
  /**
   * Returns Lit Safe html to render any Web Component
   * @param {String} tagName
   * @param {Object} keyValuePairs
   * @returns { html }
   */
  static createCustomTagLitHtml(tagName, keyValuePairs) {
    const body = `return html\`<${tagName} ${_PureSPA.generateAttributeString(
      keyValuePairs
    )}></${tagName}>\``;
    const renderCustomElement = Function.apply(null, [
      "html, css, field",
      body
    ]);
    return x`${renderCustomElement(x, i, keyValuePairs)}`;
  }
  /**
   * Generates an attribute string dynamically.
   * @param {Object} keyValuePairs
   * @returns { String } html attribute string
   */
  static generateAttributeString(keyValuePairs) {
    const body = [];
    Object.entries(keyValuePairs).forEach(([key, value]) => {
      const type = typeof value;
      switch (key) {
        case "label":
          body.push(`data-label="${value}" `);
          break;
        case "subType":
          body.push(`type="${value}" `);
          break;
        default:
          if (["boolean"].includes(type) || BOOLEAN_ATTRIBUTES.includes(key)) {
            body.push((toBoolean(value) ? key : "") + " ");
          } else if (["string", "number"].includes(type)) {
            body.push(`${key}="${value}" `);
          } else body.push(`.${key}=\${field['${key}']} `);
          break;
      }
    });
    return body.join("");
  }
  /**
   * Maps routing UrlPattern variables for Lit element dynamic rendering
   * @param {String} tagName
   * @param {Object} properties
   * @param {Object} routeData
   * @returns
   */
  static mapRouterVariables(tagName, properties, routeData) {
    properties = { ...properties ?? {} };
    const element = window.customElements.get(tagName);
    if (element && element.properties) {
      for (const [propertyName, options] of Object.entries(
        element.properties
      )) {
        if (options.routeOrigin)
          properties[propertyName] = routeData[options.routeOrigin]?.groups[propertyName];
      }
    }
    return properties;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PureSPA
});
/*! Bundled license information:

@lit-labs/ssr-dom-shim/lib/element-internals.js:
  (**
   * @license
   * Copyright 2023 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

@lit-labs/ssr-dom-shim/index.js:
  (**
   * @license
   * Copyright 2019 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

@lit/reactive-element/node/css-tag.js:
  (**
   * @license
   * Copyright 2019 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/lit-html.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-element/lit-element.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/is-server.js:
  (**
   * @license
   * Copyright 2022 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directive-helpers.js:
  (**
   * @license
   * Copyright 2020 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directive.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/async-directive.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directives/private-async-helpers.js:
  (**
   * @license
   * Copyright 2021 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)

lit-html/node/directives/until.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)
*/
//# sourceMappingURL=spa.js.map
